(function() {
    "use strict";
    var clickedMameBtnEl;
    var appId = 25;
    var addGroupUrl;

    var setParams = function() {
        var location = window.location.href;
        var linkEl = $("<a>").attr("href", location);
        var hostname = linkEl[0].hostname;
        addGroupUrl = "https://" + hostname + "/k/" + appId + "/edit";
    };
    var insertMention = function(userId, userName, userCode) {
        var editorFieldEl = $(clickedMameBtnEl)
            .parents(".ocean-ui-editor")
            .find(".ocean-ui-editor-field");

        var mentionEl = $("<a>", {
            class: "ocean-ui-plugin-mention-user ocean-ui-plugin-linkbubble-no",
            href: "/k/#/people/user/" + userCode,
            "data-mention-id": userId,
            tabindex: -1,
            style: "-webkit-user-modify: read-only;",
            text: "@" + userName
        });
        $(editorFieldEl).prepend(mentionEl);
        $(mentionEl).after("&nbsp;");
    };
    var getMembersInfo = function(membersCode) {
        var body = {
            codes: membersCode
        };
        kintone.api(
            kintone.api.url("/v1/users"),
            "GET",
            body,
            function(resp) {
                // success
                for (var i = 0; i < membersCode.length; i++) {
                    for (var j = 0; j < membersCode.length; j++) {
                        if (membersCode[i] === resp["users"][j]["code"]) {
                            insertMention(
                                resp["users"][j]["id"],
                                resp["users"][j]["name"],
                                resp["users"][j]["code"]
                            );
                        }
                    }
                }
            },
            function(error) {
                // error
            }
        );
    };
    var createMameGroupEl = function(groupName, membersCode) {
        var mameGroupEl = $("<li>", {
            class: "matomention-group"
        });
        mameGroupEl[0]["textContent"] = groupName;
        mameGroupEl[0]["membersCode"] = membersCode;
        $(".matomention-group-list")[0].append(mameGroupEl[0]);
        mameGroupEl.on("click", function() {
            getMembersInfo(this["membersCode"]);
            $(".matomention-group-list").remove();
        });
    };
    var getGroups = function() {
        var body = {
            app: appId,
            fields: ["groupName", "groupMember"]
        };
        kintone.api(
            kintone.api.url("/k/v1/records", true),
            "GET",
            body,
            function(resp) {
                // success
                $.each(resp["records"], function(i, groups) {
                    var groupName;
                    var membersCode = [];
                    groupName = groups["groupName"]["value"];
                    $.each(groups["groupMember"]["value"], function(j, members) {
                        membersCode.push(members["code"]);
                    });
                    createMameGroupEl(groupName, membersCode.reverse());
                });
            },
            function(error) {
                // error
            }
        );
    };
    var addMameBtnEvent = function(matomentionBtnEl) {
        matomentionBtnEl.on("click", function() {
            clickedMameBtnEl = this;
            $(".matomention-group-list").remove();
            var btnTop = $(this).offset().top + 20;
            var btnLeft = $(this).offset().left;

            var groupListEl = $("<ol>", {
                class: "matomention-group-list"
            });
            $(groupListEl).css({ left: btnLeft, top: btnTop });
            $("body").after(groupListEl);

            var addGroupEl = $("<li>", {
                class: "matomention-group"
            });

            var mameAppLink = $("<a>", {
                href: addGroupUrl,
                target: "_blank",
                text: "+ 新規グループ"
            });

            addGroupEl.append(mameAppLink);

            $(".matomention-group-list")[0].append(addGroupEl[0]);

            getGroups();
        });
    };
    var createMameBtnEl = function() {
        var toolbarEl = $("<div>", {
            class:
        "ocean-ui-editor-toolbar-mention goog-inline-block goog-toolbar-button"
        });
        var matomentionBtnEl = $("<div>", {
            class: "matomention-button",
            text: "まと＠"
        });

        addMameBtnEvent(matomentionBtnEl);

        var matomentionBtnBlock = $(toolbarEl).append(matomentionBtnEl);
        return matomentionBtnBlock;
    };
    $(
        document
    ).on("mousedown", ".ocean-ui-comments-commentform-textarea", function(event) {
        var commentFormEl = event["target"];
        setTimeout(function() {
            if (
                $(commentFormEl)
                .parents(".ocean-ui-comments-commentform-form")
                .find(".matomention-button").length === 0
            ) {
                $(commentFormEl)
                    .parents(".ocean-ui-comments-commentform-form")
                    .find(".ocean-ui-editor-toolbar-mention")
                    .after(createMameBtnEl());
            }
        }, 10);
    });
    $(document).click(function(event) {
        if (
            event["target"]["className"] !== "matomention-group" &&
      event["target"]["className"] !== "matomention-button"
        ) {
            $(".matomention-group-list").remove();
        }
        var commentBaseEl = $(event["target"]).parents(
            ".ocean-ui-comments-commentbase"
        );
        if (commentBaseEl.find(".matomention-button").length === 0) {
            commentBaseEl
                .find(".ocean-ui-editor-toolbar-mention")
                .after(createMameBtnEl());
        }
    });
    $(function runCode() {
        setParams();
    });
})();
